#include "cmysql.h"
#include <stdio.h>
#include <stdlib.h>


//Constructor and Destructor
CMysql::CMysql() : iRowNum(0), iFieldNum(0) , bHaveResultQuery(false), 
bIsBof(false), bIsEof(false), iCurrentPos(0), bIsConnect(false)
{
	mysql_init(&conn);
}

CMysql::~CMysql()
{
	if(&conn != NULL)
	{
		mysql_close(&conn);
	}
}

//helper function
void CMysql::helperConnection()
{
	if(&conn == NULL)
	{
		throw Exception("Exception Connect(), Connection pointer is NULL");
	}
}

void CMysql::helperQuery()
{
	if(&conn == NULL)
	{
		throw Exception("Exception Query(), Connection pointer is NULL");
	}
	if(!IsConnect())
	{
		throw Exception("Exception Connect(), Mysql   ʾҽϴ");
	}
}

int CMysql::helperFieldByName(const char *szString)
{
	// ִ  
	if(!bHaveResultQuery)
	{
		throw Exception("Exception Field() or [],    ߽ϴ");
	}
	if(iRowNum == 0)
	{
		throw Exception("Exception Field() or [], Query  شϴ ڵ ϴ");
	}
	//ʵ̸ ִ  ִٸ ε !
	for(unsigned int i=0; i<iFieldNum; i++)
	{
		if( strcmp(pfield[i].name, szString) == 0)
		{
			return i;
		}
	}
	throw Exception("Exception Field() or [] , شϴ ʵ尡 ϴ");
}

void CMysql::helperFieldByIndex(const my_ulonglong index)
{
	// ִ  
	if(!bHaveResultQuery)
	{
		throw Exception("Exception Field() or [],    ߽ϴ");
	}
	if(iRowNum == 0)
	{
		throw Exception("Exception Field() or [], Query  شϴ ڵ ϴ");
	}
	if(index > iFieldNum)
	{
		throw Exception("Exception field() or [], ʵ ε ̰ų  ѽϴ");
	}
}

void CMysql::helperMove(int n)
{
	my_ulonglong pos = iCurrentPos+n;
	if( pos == -1 )
	{
		IsBOF(true);
		IsEOF(false);
	}
	else if( pos == iRowNum)
	{
		IsBOF(false);
		IsEOF(true);
	}
	else if( (pos < 0) || (pos > iRowNum) )
	{
		throw Exception("Exception Prev() or Next() or Move(), ڵ¹ ѽϴ"); 
	}
	iCurrentPos = pos;
}
//Method
bool CMysql::Connect(const char *host, 
			 	 const char *username,
				 const char *password,
				 const char *database,
				 const unsigned int port,
				 const char *unix_socket,
				 const unsigned int client_flag)
{
	
	try
	{
		helperConnection();
	}
	catch(Exception the)
	{
		cout << "[EXCEPTION] " << the.Message() << endl;
		exit(1);
	}

	if( mysql_real_connect(&conn,
		host, 
		username, 
		password, 
		database,
		port, 
		unix_socket, 
		client_flag) == NULL )
	{
		IsConnect(false);
		return false;
	}
	IsConnect(true);
	return true;
}
bool CMysql::SelectDb(const char *szString)
{
	return !mysql_select_db(&conn, szString);
}
bool CMysql::Query(const char *szString)
{
	try
	{
		helperQuery();
	}
	catch(Exception the)
	{
		cout << "[EXCEPTION] " << the.Message() << endl;
		exit(1);
	}

	bool bRet = true;
	if(mysql_query(&conn, szString)) //raise error
	{
		bRet = false;
	}
	else
	{
		pres = mysql_store_result(&conn); // ϰ
		if(pres)
		{
			//OK,   
			iRowNum		= mysql_num_rows(pres);
			iFieldNum	= mysql_num_fields(pres);
			row         = mysql_fetch_row(pres);
			pfield		= mysql_fetch_fields(pres); //pfield[iFieldNum].name;
			IsBOF(true);
			IsEOF(false);
			bHaveResultQuery = true;
		}
		else
		{
			//Update Delete   
			if( mysql_num_rows(pres) == 0 )
			{
				iRowNum = mysql_affected_rows(&conn);
				bHaveResultQuery = false;
			}
			else
			{
				//raise error
				bRet = false;
			}
		}
	}
	return bRet;
}
char * CMysql::Field(const char *szFieldName)
{
	int index=-1;
	try
	{
		index = helperFieldByName(szFieldName);
	}
	catch(Exception the)
	{
		cout << "[EXCEPTION] " << the.Message() << endl;
		exit(1);
	}
	return row[index];
}
char * CMysql::Field(const my_ulonglong iFieldIndex)
{
	try
	{
		helperFieldByIndex(iFieldIndex);
	}
	catch(Exception the)
	{
		cout << "[EXCEPTION] " << the.Message() << endl;
		exit(1);
	}
	return row[iFieldIndex];
}
void CMysql::First()
{
	IsBOF(true);
	IsEOF(false);
	iCurrentPos = 0;
	mysql_data_seek(pres, iCurrentPos);
	row = mysql_fetch_row(pres);
}
void CMysql::Last()
{
	IsBOF(false);
	IsEOF(true);
	iCurrentPos = iRowNum-1;  //row index  0 ʹ
	mysql_data_seek(pres, iCurrentPos);
	row = mysql_fetch_row(pres);
}
void CMysql::Next()
{
	if(!IsEOF())
	{
		Move(1);
		if(IsBOF())
		{
			IsBOF(false); //Next()  ϸ ó ƴϴ
		}
	}
	else
	{
		cout << "[EXCEPTION] Exception Next(),  ڵ ϴ. ";
		exit(1);
	}
}
void CMysql::Prev()
{
	if(!IsBOF())
	{
		Move(-1);
		if(IsEOF())
		{
			IsEOF(false); //Prev()  ϸ  ƴϴ
		}
	}
	else
	{
		cout << "[EXCEPTION] Exception Prev(),  ڵ ϴ. ";
		exit(1);
	}
}
void CMysql::Move(int n)
{
	// Ѵ .
	try
	{
		helperMove(n);
	}
	catch(Exception the)
	{
		cout << "[EXCEPTION] " << the.Message() << endl;
		exit(1);
	}
	mysql_data_seek(pres, iCurrentPos);
	row = mysql_fetch_row(pres);
}
void CMysql::Disconnect()
{
	if(&conn != NULL)
	{
		mysql_close(&conn);
	}
}


